import 'package:eudcc/certificates/valuesets/country.dart';
import 'package:eudcc/certificates/valuesets/target.dart';
import 'package:json_annotation/json_annotation.dart';

part 'recovery.g.dart';

@JsonSerializable()
class Recovery {
  @JsonKey(name: "tg", fromJson: targetFromJson, toJson: targetToJson)
  final Target target;

  @JsonKey(name: "fr")
  final DateTime positive;

  @JsonKey(name: "co", fromJson: countryFromJson, toJson: countryToJson)
  final Country country;

  @JsonKey(name: "is")
  final String issuer;

  @JsonKey(name: "df")
  final DateTime from;

  @JsonKey(name: "du")
  final DateTime until;

  @JsonKey(name: "ci")
  final String identifier;

  factory Recovery.fromJson(Map<String, dynamic> json) =>
      _$RecoveryFromJson(json);

  const Recovery(this.target, this.positive, this.country, this.issuer,
      this.from, this.until, this.identifier);

  Map<String, dynamic> toJson() => _$RecoveryToJson(this);
}
