import 'package:eudcc/certificates/valuesets/country.dart';
import 'package:eudcc/certificates/valuesets/test.dart';
import 'package:eudcc/certificates/valuesets/target.dart';
import 'package:json_annotation/json_annotation.dart';

part 'test.g.dart';

@JsonSerializable()
class Test {
  @JsonKey(name: "tg", fromJson: targetFromJson, toJson: targetToJson)
  final Target target;

  @JsonKey(name: "tt", fromJson: typeFromJson, toJson: typeToJson)
  final Type type;

  @JsonKey(name: "nm")
  final String? name;

  @JsonKey(
      name: "ma", fromJson: manufacturerFromJson, toJson: manufacturerToJson)
  final Manufacturer? manufacturer;

  @JsonKey(name: "sc")
  final DateTime date;

  @JsonKey(name: "tr", fromJson: resultFromJson, toJson: resultToJson)
  final Result result;

  @JsonKey(name: "tc")
  final String facility;

  @JsonKey(name: "co", fromJson: countryFromJson, toJson: countryToJson)
  final Country country;

  @JsonKey(name: "is")
  final String issuer;

  @JsonKey(name: "ci")
  final String identifier;

  factory Test.fromJson(Map<String, dynamic> json) => _$TestFromJson(json);

  const Test(this.target, this.type, this.name, this.manufacturer, this.date,
      this.result, this.facility, this.country, this.issuer, this.identifier);

  Map<String, dynamic> toJson() => _$TestToJson(this);
}
