import 'package:eudcc/certificates/valuesets/valueset.dart';

import 'valueset.dart';

class TargetSet extends ValueSet<Target> {
  static final TargetSet _singleton = TargetSet._internal();

  factory TargetSet() {
    return _singleton;
  }

  TargetSet._internal()
      : super("specs/ehn-dcc-valuesets/disease-agent-targeted.json");

  @override
  Target buildUnknown(String name, String key) {
    return Target(name, "", false, "", "");
  }

  @override
  Target buildFromJson(Map<String, dynamic> json) {
    return Target.fromJson(json);
  }
}

Target targetFromJson(String key) {
  return TargetSet().lookup(key);
}

String targetToJson(Target co) {
  return co.key;
}

class Target extends Value {
  Target(String? displayName, String? language, bool? active, String? version,
      String? urn)
      : super(displayName, language, active, version, urn);

  factory Target.fromValue(Value v) =>
      Target(v.displayName, v.language, v.active, v.version, v.urn);

  factory Target.fromJson(Map<String, dynamic> json) =>
      Target.fromValue(Value.fromJson(json));
}
