import 'package:eudcc/certificates/valuesets/valueset.dart';

import '../valueset.dart';

class ResultSet extends ValueSet<Result> {
  static final ResultSet _singleton = ResultSet._internal();

  factory ResultSet() {
    return _singleton;
  }

  ResultSet._internal() : super("specs/ehn-dcc-valuesets/test-result.json");

  @override
  Result buildUnknown(String name, String key) {
    return Result(name, "", false, "", "");
  }

  @override
  Result buildFromJson(Map<String, dynamic> json) {
    return Result.fromJson(json);
  }
}

Result resultFromJson(String key) {
  return ResultSet().lookup(key);
}

String resultToJson(Result co) {
  return co.key;
}

class Result extends Value {
  Result(String? displayName, String? language, bool? active, String? version,
      String? urn)
      : super(displayName, language, active, version, urn);

  factory Result.fromValue(Value v) =>
      Result(v.displayName, v.language, v.active, v.version, v.urn);

  factory Result.fromJson(Map<String, dynamic> json) =>
      Result.fromValue(Value.fromJson(json));
}
