import 'package:eudcc/certificates/valuesets/valueset.dart';

import '../valueset.dart';

class TypeSet extends ValueSet<Type> {
  static final TypeSet _singleton = TypeSet._internal();

  factory TypeSet() {
    return _singleton;
  }

  TypeSet._internal() : super("specs/ehn-dcc-valuesets/test-type.json");

  @override
  Type buildUnknown(String name, String key) {
    return Type(name, "", false, "", "");
  }

  @override
  Type buildFromJson(Map<String, dynamic> json) {
    return Type.fromJson(json);
  }
}

Type typeFromJson(String key) {
  return TypeSet().lookup(key);
}

String typeToJson(Type co) {
  return co.key;
}

class Type extends Value {
  Type(String? displayName, String? language, bool? active, String? version,
      String? urn)
      : super(displayName, language, active, version, urn);

  factory Type.fromValue(Value v) =>
      Type(v.displayName, v.language, v.active, v.version, v.urn);

  factory Type.fromJson(Map<String, dynamic> json) =>
      Type.fromValue(Value.fromJson(json));
}
