import 'package:eudcc/certificates/valuesets/valueset.dart';

import '../valueset.dart';

class ManufacturerSet extends ValueSet<Manufacturer> {
  static final ManufacturerSet _singleton = ManufacturerSet._internal();

  factory ManufacturerSet() {
    return _singleton;
  }

  ManufacturerSet._internal()
      : super("specs/ehn-dcc-valuesets/vaccine-mah-manf.json");

  @override
  Manufacturer buildUnknown(String name, String key) {
    return Manufacturer(name, "", false, "", "");
  }

  @override
  Manufacturer buildFromJson(Map<String, dynamic> json) {
    return Manufacturer.fromJson(json);
  }
}

Manufacturer manufacturerFromJson(String key) {
  return ManufacturerSet().lookup(key);
}

String manufacturerToJson(Manufacturer co) {
  return co.key;
}

class Manufacturer extends Value {
  Manufacturer(String? displayName, String? language, bool? active,
      String? version, String? urn)
      : super(displayName, language, active, version, urn);

  factory Manufacturer.fromValue(Value v) =>
      Manufacturer(v.displayName, v.language, v.active, v.version, v.urn);

  factory Manufacturer.fromJson(Map<String, dynamic> json) =>
      Manufacturer.fromValue(Value.fromJson(json));
}
