import 'package:eudcc/certificates/valuesets/valueset.dart';

import '../valueset.dart';

class ProductSet extends ValueSet<Product> {
  static final ProductSet _singleton = ProductSet._internal();

  factory ProductSet() {
    return _singleton;
  }

  ProductSet._internal()
      : super("specs/ehn-dcc-valuesets/vaccine-medicinal-product.json");

  @override
  Product buildUnknown(String name, String key) {
    return Product(name, "", false, "", "");
  }

  @override
  Product buildFromJson(Map<String, dynamic> json) {
    return Product.fromJson(json);
  }
}

Product productFromJson(String key) {
  return ProductSet().lookup(key);
}

String productToJson(Product co) {
  return co.key;
}

class Product extends Value {
  Product(String? displayName, String? language, bool? active, String? version,
      String? urn)
      : super(displayName, language, active, version, urn);

  factory Product.fromValue(Value v) =>
      Product(v.displayName, v.language, v.active, v.version, v.urn);

  factory Product.fromJson(Map<String, dynamic> json) =>
      Product.fromValue(Value.fromJson(json));
}
