import 'package:eudcc/certificates/valuesets/valueset.dart';

import '../valueset.dart';

class ProphylaxisSet extends ValueSet<Prophylaxis> {
  static final ProphylaxisSet _singleton = ProphylaxisSet._internal();

  factory ProphylaxisSet() {
    return _singleton;
  }

  ProphylaxisSet._internal()
      : super("specs/ehn-dcc-valuesets/vaccine-prophylaxis.json");

  @override
  Prophylaxis buildUnknown(String name, String key) {
    return Prophylaxis(name, "", false, "", "");
  }

  @override
  Prophylaxis buildFromJson(Map<String, dynamic> json) {
    return Prophylaxis.fromJson(json);
  }
}

Prophylaxis prophylaxisFromJson(String key) {
  return ProphylaxisSet().lookup(key);
}

String prophylaxisToJson(Prophylaxis co) {
  return co.key;
}

class Prophylaxis extends Value {
  Prophylaxis(String? displayName, String? language, bool? active,
      String? version, String? urn)
      : super(displayName, language, active, version, urn);

  factory Prophylaxis.fromValue(Value v) =>
      Prophylaxis(v.displayName, v.language, v.active, v.version, v.urn);

  factory Prophylaxis.fromJson(Map<String, dynamic> json) =>
      Prophylaxis.fromValue(Value.fromJson(json));
}
