import 'package:eudcc/certificates/identity.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  test('parse identity full', () {
    var json = {
      "gn": "Isolde Erika",
      "gnt": "ISOLDE<ERIKA",
      "fn": "Musterfrau-Gößinger Müller",
      "fnt": "MUSTERFRAU<GOESSINGER<MUELLER"
    };
    var id = Identity.fromJson(json);
    expect(id.firstName, "Musterfrau-Gößinger Müller");
    expect(id.givenName, "Isolde Erika");
    expect(id.firstNameICAO9303, "MUSTERFRAU<GOESSINGER<MUELLER");
    expect(id.givenNameICAO9303, "ISOLDE<ERIKA");
  });
  test('parse identity wo givenName', () {
    var json = {"fn": "Musterfrau-Gößinger", "fnt": "MUSTERFRAU<GOESSINGER"};
    var id = Identity.fromJson(json);
    expect(id.firstName, "Musterfrau-Gößinger");
    expect(id.firstNameICAO9303, "MUSTERFRAU<GOESSINGER");
  });
}
